<!DOCTYPE html>
<html lang="en">
<head>
    
    <meta charset="utf-8">
    <title>jsdoc2 - Documentation</title>
    
    
    <script src="scripts/prettify/prettify.js"></script>
    <script src="scripts/prettify/lang-css.js"></script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc.css">
    <script src="scripts/nav.js" defer></script>
    
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
</head>
<body>

<input type="checkbox" id="nav-trigger" class="nav-trigger" />
<label for="nav-trigger" class="navicon-button x">
  <div class="navicon"></div>
</label>

<label for="nav-trigger" class="overlay"></label>

<nav >
    
    <input type="text" id="nav-search" placeholder="Search" />
    
    
    <h2><a href="index.html">Home</a></h2><h3>Objects</h3><ul><li><a href="install.html">install</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="install.html#.install_as_user">install_as_user</a></li><li data-type='method' style='display: none;'><a href="install.html#.install_as_developer">install_as_developer</a></li><li data-type='method' style='display: none;'><a href="install.html#.install_a_new_package">install_a_new_package</a></li></ul></li><li><a href="make.html">make</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="make.html#.build">build</a></li><li data-type='method' style='display: none;'><a href="make.html#.build_cpp">build_cpp</a></li><li data-type='method' style='display: none;'><a href="make.html#.build_gyp">build_gyp</a></li><li data-type='method' style='display: none;'><a href="make.html#.build_python">build_python</a></li><li data-type='method' style='display: none;'><a href="make.html#.build_public">build_public</a></li><li data-type='method' style='display: none;'><a href="make.html#.test">test</a></li><li data-type='method' style='display: none;'><a href="make.html#.clean">clean</a></li><li data-type='method' style='display: none;'><a href="make.html#.sync">sync</a></li><li data-type='method' style='display: none;'><a href="make.html#.show">show</a></li><li data-type='method' style='display: none;'><a href="make.html#.usage">usage</a></li><li data-type='method' style='display: none;'><a href="make.html#.install">install</a></li></ul></li><li><a href="jsdoc2.html">jsdoc2</a></li></ul><h3>Global</h3><ul><li><a href="global.html#make-readme">make-readme</a></li><li><a href="global.html#menu">menu</a></li></ul>
    
</nav>

<div id="main">
    
    <h1 class="page-title">jsdoc2</h1>
    

    




<section>

<header>
    
        <h2>
        
            jsdoc2
        
        </h2>
        
    
</header>

<article>
    
        <div class="container-overview">
        
            

    

    <h4 class="name" id="jsdoc2"><span class="type-signature"></span>factory jsdoc2<span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Generates an improved version of documentation.</p>
<h2>Source code documentation</h2>
<ul>
<li>
<p>Source files are in the <code>./src</code> directory and documentation is generated in the <code>./public</code> directory.</p>
</li>
<li>
<p>It uses <a href="https://jsdoc.app">jsdoc</a> documentation mechanism for Javasctipt, C/C++ and shell source code.</p>
</li>
<li>
<p>The <a href="https://www.npmjs.com/package/docdash">docdash</a> template is used here.</p>
</li>
<li>
<p>With respect to standad jsdoc processing:</p>
<ul>
<li>Classes with lower-case 1st letter are documented as &quot;factory&quot;, i.e., set of static methods.</li>
<li>Inner classes are properly documented, in the navigation menu and highlighted in page.</li>
<li>The <code>@extends</code> tag must be inserted <em>after</em> the <code>@description</code> because it is treated at the preprocessing level avoiding duplicating all methods in derived class, the <a href="https://jsdoc.app/tags-augments.html"><code>@augments</code></a> tag is still usable with standard usage.</li>
<li>Documentation footer is cleaned.</li>
</ul>
</li>
<li>
<p>A few AIDE specific tags are introduced:</p>
<ul>
<li><code>@aideAPI</code>: inserts a right floating <a href="https://line.gitlabpages.inria.fr/aide-group/aide/img/icons8-api-aide.png">icon</a> with a link to <a href="https://line.gitlabpages.inria.fr/aide-group/aide/index.html">AIDE API doc</a>.</li>
<li><code>@slides $pdf-file</code>: inserts a iframe displaying the PDF slides generated by the local LateX mechanism in landscape mode.</li>
</ul>
</li>
</ul>
<h3>Other languages documentation</h3>
<p>Since multi-language (mainly C/C++ and bash/bat commands) is targeted</p>
<ul>
<li>Files of suffixes .h, .hpp, .sh are scanned to extract the <code>/** ../.. </code> comment sections,
e.g., in the following <code>.sh</code> file, where the <code>#</code> prefix allows to comment the documentation lines.</li>
</ul>
<pre class="prettyprint source"><code># /** This factory allows ... .
#  * @class factory_name
#  *&#47;
# /**
#  * @function function_name
#  * @memberof factory_name
#  * @static
#  * @description This function ... 
#  ../..
#  *&#47;
</code></pre>
<h3>Illustrative examples of documentation:</h3>
<ul>
<li>A Javascript class and inner method: <a href="https://gitlab.inria.fr/line/aide-group/aideweb/-/blob/master/src/HttpQuery.js">source</a> and related <a href="https://line.gitlabpages.inria.fr/aide-group/aideweb/HttpQuery.html">documentation</a></li>
<li>A Javascript factory: <a href="https://gitlab.inria.fr/line/aide-group/wjson/-/blob/master/src/wJSON.js">source</a> and related <a href="https://line.gitlabpages.inria.fr/aide-group/wjson/wJSON.html">documentation</a>.</li>
<li>A C/C++ Class and inner method: <a href="https://gitlab.inria.fr/line/aide-group/wjson/-/blob/master/src/WJSONWriter.hpp">source</a> and <a href="https://line.gitlabpages.inria.fr/aide-group/wjson/WJSONWriter.html">documentation</a>.</li>
<li>A C/C++ static procedure in a given namespace: <a href="https://gitlab.inria.fr/line/aide-group/aidesys/-/blob/master/src/random.hpp">source</a> and related <a href="https://line.gitlabpages.inria.fr/aide-group/aidesys/random.html">documentation</a>.</li>
<li>A shell script documentation: <a href="https://gitlab.inria.fr/line/aide-group/creaspot/-/blob/master/src/wcreaspot.sh">source</a> and <a href="https://line.gitlabpages.inria.fr/aide-group/creaspot/wcreaspot.html">documentation</a>.</li>
</ul>
<h2>README.md generation from the package.json</h2>
<ul>
<li>In the home page:
<ul>
<li>The <code>README.md</code> generated from the <code>package.json</code> is used for the home page.</li>
</ul>
</li>
</ul>
<p>The <a href="https://docs.npmjs.com/cli/v6/configuring-npm/package-json#name">name</a>,
one line <a href="https://docs.npmjs.com/cli/v6/configuring-npm/package-json#description-1">description</a>,
documentation <a href="https://docs.npmjs.com/cli/v6/configuring-npm/package-json#homepage">home page</a>,
<a href="https://docs.npmjs.com/cli/v6/configuring-npm/package-json#version">version</a>,
<a href="https://docs.npmjs.com/cli/v6/configuring-npm/package-json#license">license</a>,
<a href="https://docs.npmjs.com/cli/v6/configuring-npm/package-json#people-fields-author-contributors">author</a> as a unique author or contributors,
git <a href="https://docs.npmjs.com/cli/v6/configuring-npm/package-json#repository">repository</a> meta-data,
and an optional custom field <code>usage</code> (allowing to write more documentation)
are taken into account using the following format:</p>
<pre class="prettyprint source"><code>{
 &quot;name&quot;: &quot;$name&quot;,
 &quot;description&quot;: &quot;$one-line-description&quot;,
 &quot;homepage&quot;: &quot;$the-package-documentation-url&quot;,
 &quot;version&quot;: &quot;0.1.0&quot;,
 &quot;license&quot;: &quot;CECILL-C&quot;,
 &quot;author&quot;: &quot;$Firstname $Lastname &lt;$email>($url), ../..&quot;,
 &quot;repository&quot;: {
   &quot;type&quot;: &quot;git&quot;,
   &quot;url&quot;: &quot;$git-url&quot;
 &quot;usage&quot; : [
   &quot;$usage-1st-line&quot;,
   &quot;$usage-2nd-line ../..&quot;
 ],
../..
</code></pre>
<p>while <a href="https://docs.npmjs.com/cli/v6/configuring-npm/package-json#dependencies">dependencies</a>,  <a href="https://docs.npmjs.com/cli/v6/configuring-npm/package-json#devdependencies">devDependencies</a> and <a href="https://docs.npmjs.com/cli/v6/configuring-npm/package-json#scripts">test script</a> are also taken into account.</p>
<ul>
<li>
<p>The following standard <code>install</code>, <code>build</code>, <code>test</code>, <code>clean</code>, <code>sync</code> npm commands are documented.</p>
</li>
<li>
<p>It is assumed that the repository is a standard <code>git</code> repository, expliciting the source file location.</p>
</li>
<li>
<p>Several contributors acn also be defined, instead of the author, using the contsruct:</p>
</li>
</ul>
<pre class="prettyprint source"><code> &quot;contributors&quot;: [
   { 
     &quot;name&quot;: &quot;$Firstname $Lastname&quot;, 
     &quot;email&quot;: &quot;$email&quot;, 
     &quot;url&quot;: &quot;$url&quot; 
   },
  ../..
 ],
</code></pre>
<h2>Generation of complementary images, figures and LateX files.</h2>
<ul>
<li>From the <code>./src</code> directory to the <code>./public</code> documentation directory:
<ul>
<li>Images in <code>.png</code> format are copied .</li>
<li>Figures in <code>.odg</code> libreoffice format are exported and copied.</li>
<li>LaTex documentation pages are generated using local <code>.tex</code> and <code>.bib</code> input files.</li>
<li><a href="https://en.wikipedia.org/wiki/Maple_(software)">Maple</a> figures and formula are generated runing the <code>.mpl</code> input file.</li>
</ul>
</li>
</ul>
<h3>Using LaTeX to generate complementary documents</h3>
<ul>
<li>
<p>Uses a <a href="https://gitlab.inria.fr/line/aide-group/aide/-/blob/master/etc/www/tex/etc/preamble.tex">preamble</a> to the LaTeX source file in order to generate a landscape text presentation.</p>
</li>
<li>
<p>Adds the ./src/*.bib references if \cite{} command.</p>
</li>
<li>
<p>Provides a few additional LaTeX commands as detailled below.</p>
</li>
<li>
<p>Manages *.png and *.odg image files the latex source file directory.</p>
</li>
<li>
<p>Manages Maple *.mpl files to generates *.jpg figures or *.tex output, as detailled below.</p>
</li>
<li>
<p>Shows the obtained pdf file if the -show options is present</p>
</li>
<li>
<p>Notice: Target files are stored in the ./build/www/assets/tex directory,</p>
<ul>
<li>and an index.html page lists the generated files.</li>
</ul>
</li>
<li>
<p>Warning: It is not possible to insert latex formula in source code documentation.</p>
</li>
</ul>
<h4>The LaTeX preamble mechanism</h4>
<ul>
<li>LateX files of name <code>[a-z]*.tex</code> are compiled as landscape PDF documentation.
<ul>
<li>Files with names <code>_*.tex</code> are not compiled and considered as include files.</li>
<li>A LateX file can be used for both the documentation and an external draft, using the <code>\aidebuild</code> directive and conditional compilation:</li>
</ul>
</li>
</ul>
<pre class="prettyprint source"><code>\ifdefined\aidebuild
% Part of text only appearing in aidebuild documentation
\else
% Part of text not appearing in aidebuild documentation
\fi
</code></pre>
<p>This script uses a <a href="https://gitlab.inria.fr/line/aide-group/aide/-/blob/master/etc/www/tex/etc/preamble.tex">preamble</a> which defines:</p>
<ul>
<li>A landscape A4 PDF minimal display of text or plate, i.e., slide, to be displayed in the documentation bundle, using a structure of the form.</li>
</ul>
<pre class="prettyprint source"><code>\subsection*{Document title}
\subsubsection*{First page title}
% Here page content
\clearpage
\subsubsection*{Next page title}
% etc..
</code></pre>
<p>without any preamble such as declaration of <code>\begin{document}</code> etc... and without <code>\end{document}</code> at the end.</p>
<ul>
<li>Defines a few additional LaTeX commands as detailled below.</li>
</ul>
<p>This design choice allows you to both generate standard documentation pages and directly include the text, usually as appendix, in any other publication.</p>
<h4>The LaTeX additional commands</h4>
<ul>
<li>
<p>A minimal set of command to generate slide:</p>
<ul>
<li><code>\slide{#content}</code>: A 24 cm x 16.5 cm plate which contents is defined in <code>#content</code>.</li>
<li><code>\stitle{#content}</code>: The slide title, if any.</li>
<li><code>\scenter{#content}</code>, <code>\sright{#content}</code>: A centered, or right piece of text.</li>
<li><code>\stwo{#left-width}{#right-width}{#left-content}{#right-content}</code>: Separate the slides in two collons so that <code>#left-width + #right-width = 1</code> with two contents.</li>
</ul>
</li>
<li>
<p>A few miscellaneous commands:</p>
<ul>
<li><code>\deq</code>: Defines a <code>=</code> corresponding to a definition.</li>
<li><code>\tab</code>: A 6 mm robust horizontal tabulation.</li>
<li><code>\eqline{#math-content}</code>: A on-line minimal display of a mathematical equation.</li>
<li><code>\hhref{#link}</code>: A link which text is the link itself.</li>
</ul>
</li>
</ul>
<h3>Using Maple to generate figures and formula</h3>
<p>In order to generate a figure the following Maple commands are available, as for example:</p>
<pre class="prettyprint source"><code>plotsetup(jpeg, plotoutput=&quot;figure-name.jpg&quot;, plotoptions=&quot;width=600,height=600&quot;);
# Here a plot(../.. or plot3d(../.. command
plotsetup(x11);
</code></pre>
<p>while a LaTeX command like this one, allows to insert the figure:</p>
<pre class="prettyprint source"><code>\includegraphics[width=0.9\textwidth]{./figure-name.jpg}
</code></pre>
<p><em>Using Maple to generate LaTeX formula</em></p>
<p>In order to generate a latex formula form LaTeX, a command of the form</p>
<pre class="prettyprint source"><code>latex(Int(1/(x^2+1), x) = int(1/(x^2+1), x), &quot;latex-file-name.tex&quot;);
</code></pre>
<p>while a LaTeX command like this one, allows to insert the formula:</p>
<pre class="prettyprint source"><code>\eqline{\input{latex-file-name.tex}}</code></pre></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>






























        
        </div>
    

    

    

    
    
    

     

    

    

    

    

    
</article>

</section>




    
    
</div>

<br class="clear">

<footer>
    <div style='float: right;font-style: italic;'>2025-01-22 version.</div>
</footer>

<script>prettyPrint();</script>
<script src="scripts/polyfill.js"></script>
<script src="scripts/linenumber.js"></script>

<script src="scripts/search.js" defer></script>


<script src="scripts/collapse.js" defer></script>


</body>
</html>